PROC GLOBAL

alpha (26) alphalst = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

alpha (26) alphanew;
numeric totlen,aok,alphsize,l,a;


function alphachk ( alpha(26) alphavar, alphlen, alpha(10) tail );

	{ Function to check entry of alpha string variables }
	{ alphlen: length of first consecutive part for the field, e.g. A-G is 7 }
	{ tail:    the residual characters in the valid string, i.e., X, Y, W, or Z }
	alphanew = alphalst[1:alphlen];         { string of acceptable values }
	alphanew = concat( strip(alphanew), strip(tail) );
	totlen = length(strip(alphanew));
	aok = 0;      { if aok = 0, string is bad, if aok = 1, string is good; assume bad to start, i.e., empty string }
	alphsize = length(strip(alphavar));
	if alphsize then   { not empty string }
		{ check for "?" as only character }
		aok = (alphavar[1:1] = "?" & alphsize = 1);
		if !aok then     { if not a single "?", check string }
			aok = 1;       { now assume string is good until we know otherwise }
			l = 1;         { l is position in string of acceptable values }
			a = 1;         { a is position in input string }
			{ loop while the string is still good and there are more letters }
			while aok & a <= alphsize do
				aok = pos(alphavar[a:1],alphanew[l:totlen-l+1]);
				if aok then     { letter is acceptable }
					l = l + aok;  { increment l to position after letter in string of acceptable values }
					a = a + 1     { increment a to next letter in input string }
				endif
			enddo
		endif
	endif;
	alphachk = (!aok);    { alphachk = 0 - if string is good, = 1 - if string is bad }
end;


PROC SDFSDF_FF


PROC STRAD

	if alphachk(STRAD,4,"") then
		errmsg("Invalid combination. Can only enter A-D.");
		reenter;
	endif;


PROC STRAM

	if alphachk(STRAM,13,"") then
		errmsg("Invalid combination. Can only enter A-M.");
		reenter;
	endif;


PROC STRAD_XY

	if alphachk(STRAD_XY,4,"XY") then
		errmsg("Invalid combination. Can only enter A-D, X-Y.");
		reenter;
	endif;


